using System;
using System.Web;
using System.Data;
using System.Text;
using com.common.DAL;
using com.common.util;
using com.common.classes;
using com.ties.DAL;
using com.ties.classes;
using System.Threading;
using System.Collections;




namespace com.ties.BAL
{
	/// <summary>
	/// Summary description for MCAJobMgrBAL.
	/// </summary>
	public class MCAJobMgrBAL 
	{
		JobStatusInfo	m_jobStatusInfo;

		String			m_strAppID = null;
		String			m_strEnterpriseID = null;
		int				m_iAccountYear = 0;
		short			m_iAccountMonth	= 0;


		public MCAJobMgrBAL()
		{
		}

		public JobStatusInfo AllocateMCAJob(String strAppID, String strEnterpriseID, int iAccountYear, short iAccountMonth, decimal iJobID, HttpContext context)
		{
			//Step 1 :	Begin a database transcation

			

			m_strAppID		= strAppID;
			m_strEnterpriseID	= strEnterpriseID;
			m_iAccountYear	= iAccountYear;
			m_iAccountMonth	= iAccountMonth;


			DbConnection dbConApp = null;
			IDbTransaction transactionApp = null;
			IDbConnection conApp = null;

			//Get App dbConnection

			dbConApp = DbConnectionManager.GetInstance().GetDbConnection(strAppID,strEnterpriseID);

			if(dbConApp == null)
			{
				Logger.LogTraceError("MCAJobMgrBAL","AllocateMCAJob","SDM002","dbConApp is null");
				throw new ApplicationException("Connection to Database failed",null);
			}

			//Begin Core and App Transaction

			conApp = dbConApp.GetConnection();
			
			if(conApp == null)
			{
				Logger.LogTraceError("MCAJobMgrBAL","AllocateMCAJob","SDM002","conApp is null");
				throw new ApplicationException("Connection to Database failed",null);
			}

			try
			{
				dbConApp.OpenConnection(ref conApp);
			}
			catch(ApplicationException appException)
			{
				if(conApp != null)
				{
					conApp.Close();
				}
				Logger.LogTraceError("MCAJobMgrBAL","AllocateMCAJob","SDM003","Error opening connection : "+ appException.Message.ToString());
				throw new ApplicationException("Error opening database connection ",appException);
			}
			catch(Exception exception)
			{
				if(conApp != null)
				{
					conApp.Close();
				}

				Logger.LogTraceError("MCAJobMgrBAL","AllocateMCAJob","SDM003","Error opening connection : "+ exception.Message.ToString());
				throw new ApplicationException("Error opening database connection ",exception);
			}


			transactionApp = dbConApp.BeginTransaction(conApp,IsolationLevel.ReadCommitted);


			if(transactionApp == null)
			{
				Logger.LogTraceError("MCAJobMgrBAL","AllocateMCAJob","SDM002","transactionApp is null");
				throw new ApplicationException("Failed Begining a App Transaction..",null);
			}


			//			If the job_status "In Progress" is not found then
			//			-	Insert a new Job record with autogenerated jobid
			//			-	Start the new thread to execute the job
			//			-	Commit the transaction if the thread is spawned successfull
			//			-	Rollback the transaction if any error creating the transaction
			//			-	Show user message and return.

			try
			{
				//Step 2 :	Lock the Cost_Allocation_Task table and read the job_status
				DataSet dsJobStatus = MCAJobMgrDAL.GetMCAJobStatusDS(dbConApp, transactionApp, conApp,strAppID, strEnterpriseID);
				
				int iNumRows = dsJobStatus.Tables[0].Rows.Count;

				if(iNumRows > 0)
				{
					m_jobStatusInfo = new JobStatusInfo();

					DataRow drCurrent = dsJobStatus.Tables[0].Rows[0];

					m_jobStatusInfo.iJobID = Convert.ToDecimal(drCurrent["jobid"]);
					m_jobStatusInfo.dtStartDateTime = (DateTime) drCurrent["start_datetime"];
					m_jobStatusInfo.strRemark = (String) drCurrent["remark"];
					m_jobStatusInfo.strJobStatusMessageID = "MCA_JOB_ALREADY_INPROGRESS";
					transactionApp.Rollback();
					
					//This job is in process
					//end transacttion using rollback
					//Return the jobid which is in process
				}
				else
				{
					//Create a new job
					//Insert the the job record					
					m_jobStatusInfo = MCAJobMgrDAL.AddMCAJob(dbConApp,transactionApp,conApp,strAppID,strEnterpriseID,iAccountYear,iAccountMonth,iJobID);
					m_jobStatusInfo.strJobStatusMessageID = "MCA_JOB_STARTED";
					//Start the new job thread
					Thread mcaJobBatch = new Thread(new ThreadStart(this.Allocate));
					
					mcaJobBatch.Name = Utility.GetJobName(strAppID,strEnterpriseID,JobType.MCAJob);
					mcaJobBatch.Start();
					Hashtable appThreads = (Hashtable)context.Application["APP_THREADS"];

					if(appThreads != null)
					{
						appThreads[mcaJobBatch.Name] = mcaJobBatch;
					}
					//Commit the transaction
					transactionApp.Commit();
				}
			}
			catch(ApplicationException appException)
			{
				
				try
				{
					transactionApp.Rollback();
					Logger.LogTraceInfo("MCAJobMgrBAL","AllocateMCAJob","SDM002","App db delete transaction rolled back.");

				}
				catch(Exception rollbackException)
				{
					Logger.LogTraceError("MCAJobMgrBAL","AllocateMCAJob","SDM002","Error during app transanction roll back "+ rollbackException.Message.ToString());
				}


				Logger.LogTraceError("MCAJobMgrBAL","AllocateMCAJob","SDM002","Delete Transaction Failed : "+ appException.Message.ToString());
				throw new ApplicationException("Error deleting Status Code "+appException.Message,appException);
			}
			catch(Exception exception)
			{
				try
				{
					transactionApp.Rollback();
					Logger.LogTraceInfo("MCAJobMgrBAL","AllocateMCAJob","SDM002","App db delete transaction rolled back.");

				}
				catch(Exception rollbackException)
				{
					Logger.LogTraceError("MCAJobMgrBAL","AllocateMCAJob","SDM002","Error during app transanction roll back "+ rollbackException.Message.ToString());
				}

				Logger.LogTraceError("MCAJobMgrBAL","AllocateMCAJob","SDM004","delete Transaction Failed : "+ exception.Message.ToString());
				throw new ApplicationException("Error deleting Status Code "+exception.Message,exception);
			}
			finally
			{
				if(conApp != null)
				{
					conApp.Close();
				}
			}

			return m_jobStatusInfo;
		}

		private void Allocate()
		{

			DbConnection	dbConMCAThread = null;
			IDbConnection	conMCAThread = null;
			
			try
			{
				Logger.LogDebugInfo("MCAJobMgrBAL","Allocate","MCAJ001","MCA Thread started : ");

				//Get the mca dataset

				DataSet dsMCA = MonthlyCostAccountMgrDAL.GetMCADS(m_strAppID,m_strEnterpriseID,m_iAccountYear,m_iAccountMonth);

				int iCostCodeCount = dsMCA.Tables[0].Rows.Count;
						
				//Read the currency_decimal defined at enterprise level
				Enterprise enterprise = new Enterprise();
				enterprise.Populate(m_strAppID,m_strEnterpriseID);

				//Delete records from Shipment_Cost table for the current jobid IF ANY
				MCAJobMgrDAL.DeleteShipmentCostRecords(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID);

				//Get the connection object.


				//Get App dbConnection

				dbConMCAThread = DbConnectionManager.GetInstance().GetDbConnection(m_strAppID,m_strEnterpriseID);

				if(dbConMCAThread == null)
				{
					Logger.LogTraceError("MCAJobMgrBAL","Allocate()","SDM002","dbConMCAThread is null");
					MCAJobMgrDAL.UpdateMCAJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"E","Error Connecting Database");
				}

				//Begin Core and App Transaction

				conMCAThread = dbConMCAThread.GetConnection();
			
				if(conMCAThread == null)
				{
					Logger.LogTraceError("MCAJobMgrBAL","Allocate()","SDM002","conMCAThread is null");
					MCAJobMgrDAL.UpdateMCAJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"E","Error Connecting Database");
				}

				try
				{
					dbConMCAThread.OpenConnection(ref conMCAThread);
				}
				catch(ApplicationException appException)
				{
					if(conMCAThread != null)
					{
						conMCAThread.Close();
					}
					Logger.LogTraceError("MCAJobMgrBAL","Allocate()","SDM003","Error opening connection : "+ appException.Message);
					MCAJobMgrDAL.UpdateMCAJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"E",appException.Message);
				}
				catch(Exception exception)
				{
					if(conMCAThread != null)
					{
						conMCAThread.Close();
					}

					Logger.LogTraceError("MCAJobMgrBAL","Allocate()","SDM003","Error opening connection : "+ exception.Message);
					MCAJobMgrDAL.UpdateMCAJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"E",exception.Message);
				}


				String strFromDate = "01/";

				if(m_iAccountMonth <10)
				{
					strFromDate += "0";
				}
				
				strFromDate += m_iAccountMonth+"/"+m_iAccountYear;

				DateTime dtFrom = DateTime.ParseExact (strFromDate, "dd/MM/yyyy", null);
				DateTime dtTo = dtFrom.AddMonths(1);
				

				String strDateFrom = Utility.DateFormat(m_strAppID,m_strEnterpriseID,dtFrom,DTFormat.DateTime);
				String strDateTo = Utility.DateFormat(m_strAppID,m_strEnterpriseID,dtTo,DTFormat.DateTime);


				String strSelectQuery = "select Booking_No, consignment_no, tot_Wt, tot_dim_Wt  from Shipment ";
				String strCountQuery = "select count(*) as cnt  from Shipment ";
				String strTotWtQuery = "select sum(tot_wt) as tot_wt from Shipment ";
				String strTotDimWtQuery = "select sum(tot_dim_wt) as tot_dim_wt from Shipment ";

				StringBuilder strBuilderWhereClause = new StringBuilder();
				strBuilderWhereClause.Append("where applicationid = '");
				strBuilderWhereClause.Append(m_strAppID);
				strBuilderWhereClause.Append("' and enterpriseid = '");
				strBuilderWhereClause.Append(m_strEnterpriseID);
				strBuilderWhereClause.Append("' and booking_datetime >= ");
				strBuilderWhereClause.Append(strDateFrom);
				strBuilderWhereClause.Append("and booking_datetime < ");
				strBuilderWhereClause.Append(strDateTo);

				String strWhereClause = strBuilderWhereClause.ToString();

				//Read the total number of shipments for the specified year and month

				strCountQuery += strWhereClause;

				IDbCommand dbCommand = dbConMCAThread.CreateCommand(strCountQuery,CommandType.Text);
				dbCommand.Connection = conMCAThread;

				int iShipmentRecordsCount = 0;

				Object objShipmentRecordsCount = dbCommand.ExecuteScalar();

				if(Utility.IsNotDBNull(objShipmentRecordsCount))
				{
					iShipmentRecordsCount  = (int)objShipmentRecordsCount;
				}


				//Read the total wt of all shipments for the specified year and month
				dbCommand.CommandText = strTotWtQuery + strWhereClause;

				decimal decAggTotWt = 0;

				Object objAggTotWt = dbCommand.ExecuteScalar();

				if(Utility.IsNotDBNull(objAggTotWt))
				{
					decAggTotWt  = (decimal)objAggTotWt;
				}


				//Read the total dim wt of all shipments for the spcified year and month
				dbCommand.CommandText = strTotDimWtQuery + strWhereClause;

				decimal decAggDimTotWt = 0;

				Object objAggDimTotWt = dbCommand.ExecuteScalar();


				if(Utility.IsNotDBNull(objAggDimTotWt))
				{
					decAggDimTotWt  = (decimal)objAggDimTotWt;
				}


				//Read each shipment record one by one using a data reader and iterate throught it
				dbCommand.CommandText = strSelectQuery + strWhereClause;

				IDataReader shipmentDR = (IDataReader)dbConMCAThread.ExecuteQuery(dbCommand,ReturnType.DataReaderType);



				while(shipmentDR.Read())
				{
					int iBookingNo			= shipmentDR.GetInt32(0);
					String strConsignmentNo = shipmentDR.GetString(1);
					decimal decTotWt		= shipmentDR.GetDecimal(2);
					decimal decTotDimWt		= shipmentDR.GetDecimal(3);

					//Loop throught all available cost codes for the specified year and month
					for(int i = 0; i < iCostCodeCount; i++)
					{
						String strCostCode = null;
						decimal decCostAmt = 0;

						DataRow drEach = dsMCA.Tables[0].Rows[i];
						if((drEach["cost_code"] != null) && (!drEach["cost_code"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							strCostCode = (String)drEach["cost_code"];														
						}

						if((drEach["cost_amt"] != null) && (!drEach["cost_amt"].GetType().Equals(System.Type.GetType("System.DBNull"))))
						{
							decCostAmt = (decimal)drEach["cost_amt"];														
						}

						decimal decAmtAllocByConsignment = Math.Round((decCostAmt/iShipmentRecordsCount),enterprise.CurrencyDecimal);
						decimal decAmtAllocByWt = Math.Round(((decCostAmt/decAggTotWt)*decTotWt),enterprise.CurrencyDecimal);
						decimal decAmtAllocByDimWt = Math.Round(((decCostAmt/decAggDimTotWt)*decTotDimWt),enterprise.CurrencyDecimal);

						//Insert record into Shipment_Cost table and update record into Monthly_Cost_Account in transaction

						MonthlyCostAccount structMCA = new MonthlyCostAccount();

						structMCA.strCostCode = strCostCode;
						structMCA.iAccountYear = m_iAccountYear;
						structMCA.iAccountMonth = m_iAccountMonth;
						structMCA.strAllocated = "Y";
						structMCA.iJobID = m_jobStatusInfo.iJobID;

						ShipmentCost structShipmentCost = new ShipmentCost();

						structShipmentCost.iBookingNo = iBookingNo;
						structShipmentCost.strConsignmentNo = strConsignmentNo;
						structShipmentCost.strCostCode = strCostCode;
						structShipmentCost.iJobID = m_jobStatusInfo.iJobID;
						structShipmentCost.decAmtAllocByConsignment = decAmtAllocByConsignment;
						structShipmentCost.decAmtAllocByWt = decAmtAllocByWt;
						structShipmentCost.decAmtAllocByDimWt = decAmtAllocByDimWt;

						MonthlyCostAccountMgrDAL.AddModifyMCAShipmentCost(m_strAppID,m_strEnterpriseID,structMCA,structShipmentCost);
					} //End of for loop for all cost codes
				} //End of while for all shipment records

				shipmentDR.Close();

				//Set the status in Cost_Allocation_Task table as Completed. Also put end_datetime
				MCAJobMgrDAL.UpdateMCAJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"C","Job Completed Successfully");
	
			}
			catch(ApplicationException appException)
			{
				String strMsg = "";
				Logger.LogTraceError("MCAJobMgrBAL","Allocate","SDM002", "Error in MCA Thread : "+ appException.Message.ToString());
				if(appException.Message.IndexOf("Thread was being aborted") != -1)
				{
					strMsg = "Cost Allocation Job was aborted.";
				}
				else
				{
					strMsg = appException.Message;
				}

				MCAJobMgrDAL.UpdateMCAJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"E",strMsg);
			}
			catch(ThreadAbortException threadAbortException)
			{
				String strMsg = "Cost Allocation Job was aborted.";
				Logger.LogTraceError("MCAJobMgrBAL","Allocate","SDM002", "Thread Aborted : "+ threadAbortException.Message.ToString());
				MCAJobMgrDAL.UpdateMCAJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"E",strMsg);
			}
			catch(Exception exception)
			{
				Logger.LogTraceError("MCAJobMgrBAL","Allocate","SDM004","Error in MCA Thread : "+ exception.Message);
				MCAJobMgrDAL.UpdateMCAJobStatus(m_strAppID,m_strEnterpriseID,m_jobStatusInfo.iJobID,DateTime.Now,"E",exception.Message);
			}
			finally
			{
				if(conMCAThread != null)
				{
					conMCAThread.Close();
				}
			}
		}
	}
}
